package org.nl.acs.storage_cell.service;

import org.nl.acs.common.base.PageInfo;
import org.nl.acs.common.base.CommonService;
import org.nl.acs.storage_cell.domain.StorageCell;
import org.nl.acs.storage_cell.service.dto.StorageCellDto;
import org.nl.acs.storage_cell.service.dto.StorageCellQueryParam;
import org.springframework.data.domain.Pageable;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
* @author jiaolm
* @date 2023-05-09
*/
public interface StorageCellService extends CommonService<StorageCell>  {

    static final String CACHE_KEY = "storageCell";

    /**
    * 查询数据分页
    * @param query 条件
    * @param pageable 分页参数
    * @return PageInfo<StorageCellDto>
    */
    PageInfo<StorageCellDto> queryAll(StorageCellQueryParam query, Pageable pageable);

    /**
    * 查询所有数据不分页
    * @param query 条件参数
    * @return List<StorageCellDto>
    */
    List<StorageCellDto> queryAll(StorageCellQueryParam query);

    StorageCell getById(String id);
    StorageCellDto findById(String id);

    /**
     * 插入一条新数据。
     */
    int insert(StorageCellDto resources);
    int updateById(StorageCellDto resources);
    int removeById(String id);
    int removeByIds(Set<String> ids);

    /**
    * 导出数据
    * @param all 待导出的数据
    * @param response /
    * @throws IOException /
    */
    // void download(List<StorageCellDto> all, HttpServletResponse response) throws IOException;

    /**
     * 查询数据分页
     *
     * @param whereJson 条件
     * @param page      分页参数
     * @return Map<String, Object>
     */
    Map<String, Object> queryAll(Map whereJson, Pageable page);

    /**
     * 查询所有数据不分页
     *
     * @param whereJson 条件参数
     * @return List<StorageCellDto>
     */
    List<StorageCellDto> queryAll(Map whereJson);



    /**
     * 根据编码查询
     *
     * @param code code
     * @return StorageCell
     */
//    StorageCellDto findByCode(String code);

    /**
     * 根据地址查询
     *
     * @param address address
     * @return StorageCell
     */
//    StorageCellDto findByAddress(String address);


    /**
     * 创建
     *
     * @param dto /
     */
    void create(StorageCellDto dto);

    /**
     * 编辑
     *
     * @param dto /
     */
    void update(StorageCellDto dto);

    /**
     * 多选删除
     *
     * @param ids /
     */
    void deleteAll(String[] ids);

    /**
     * 导出数据
     *
     * @param dtos     待导出的数据
     * @param response /
     * @throws IOException /
     */
    void download(List<StorageCellDto> dtos, HttpServletResponse response) throws IOException;
}
